import random
import timeit

data = list(range(1_000))
random.shuffle(data)
# (1)線形探索
timeit.timeit(lambda: 1 in data)

# ソートするコストは高い
timeit.timeit(lambda: sorted(data))

# 何度も探索する場合はソートしておく
datasorted = sorted(data)

# (2)二分探索は(1)線形探索より速い
timeit.timeit(lambda: bisect.bisect(datasorted, 1))

# set へ変換するコストは高い
timeit.timeit(lambda: set(data))

# 何度も探索する場合はsetに変換しておく
dataset = set(data)

# (3)ハッシュ探索は(2)二分探索より速い
timeit.timeit(lambda: 1 in dataset)